
#######  This is the same as MSM-LP-impact-ART.R except I've changed the criteria for LP to be CD4<350

#######  Aim 3: Impact of starting ART for those who are late presenters (LP)

setwd("~/Box Sync/old-laptop/documents/yanin-paco-LHI-2015")
#setwd("C:\Users\vegay\Documents\CCASAnet\Paco_Impact of LHI on mortality")


#Drop what is in global environment
rm(list=ls())

cd4<-read.csv("lab_cd4.csv")
load ("basic13D-CD4-350.rda")


basic13E<-basic13D[!is.na(basic13D$LP)&basic13D$LP==1,]

baseMM1<-basic13E[,c("site","patient_id","birth_d","baseline_d","hivdiagnosis_d","male",
                               "AIDS_ART","AIDS_Enrol","FirstART_d",
                               "death_d","l_alive_d","death_y","art_class","cd4Enrol",#"cd4HAART"
                               "LP","ce_d","ce_id")]

baseMM1$last<-with(baseMM1,as.Date(l_alive_d)+30)
baseMM1$last<-as.Date(baseMM1$last,origin='1970-01-01')

monthly <- lapply(split(baseMM1[,c('patient_id','baseline_d','last')],baseMM1$patient_id),FUN=function(y){
                  tmp.seq <- seq(y[,'baseline_d'], y[,'last'], by="month")})
times_per_id <- sapply(monthly, FUN=function(y){length(y)}, simplify=TRUE)

all_visits <- data.frame('patient_id'=rep(names(times_per_id), times=as.numeric(times_per_id)))

all_visits$monthly_date <- unlist(monthly)
all_visits$monthly_date <- as.Date(all_visits$monthly_date, origin='1970-01-01')

all_visits$month <- NA
split(all_visits$month, all_visits$patient_id) <- lapply(split(all_visits[,'patient_id'], all_visits[,'patient_id']),FUN=function(y){
  seq(1,length(y)) })


all_visits$FirstART_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'FirstART_d']
all_visits$birth_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'birth_d']
all_visits$baseline_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'baseline_d']
all_visits$hivdiagnosis_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'hivdiagnosis_d']
all_visits$l_alive_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'l_alive_d']
all_visits$site <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'site']
all_visits$male <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'male']
all_visits$age <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'age']
all_visits$death_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'death_d']
all_visits$cd4Enrol <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4Enrol']
all_visits$route <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'route']
all_visits$regimen <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'art_class']
all_visits$LP <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'LP']
all_visits$ce_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'ce_d']
all_visits$ce_id <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'ce_id']
#all_visits$cd4.lt.200_d<-baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4_d']
#all_visits$cd4.lt.200<-baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4.lt.200']


all_visits$id_month<- paste(all_visits$patient_id,all_visits$month,sep='.')


require(lubridate)
ord2<-order(cd4$site,cd4$patient_id,cd4$cd4_d)
cd4<-cd4[ord2,]

cd4$baseline_d<-baseMM1[match(cd4$patient_id,baseMM1$patient_id, nomatch=NA),'baseline_d']
cd4<-cd4[!is.na(cd4$baseline_d),]
cd4$month<-NA
cd4$month<- ceiling((as.numeric(as.Date(cd4$cd4_d))-as.numeric(as.Date(cd4$baseline_d))  )/30)+1 ## +1 added by Bryan
cd4$id_month <- paste(cd4$patient_id,cd4$month,sep='.')

cd4$cd4_new <- NA
split(cd4$cd4_new, cd4$id_month) <- lapply(split(cd4$cd4_v, cd4$id_month), FUN=function(y){
  if(length(y) > 1){
    mean(y,na.rm=TRUE)
  } else {
    y
  } })
cd4 <- subset(cd4, !duplicated(id_month))

all_visits$cd4 <- cd4[match(all_visits$id_month, cd4$id_month,nomatch=NA),'cd4_new']
all_visits$cd4_d <- cd4[match(all_visits$id_month, cd4$id_month,nomatch=NA),'cd4_d']

all_visits$cd4_updated <- unsplit(lapply(split(all_visits$cd4, all_visits$patient_id), FUN=function(y){
  L <- !is.na(y);y[c(NA,which(L))[cumsum(L)+1]]}),
  all_visits$patient_id)
all_visits$cd4_updated<-with(all_visits, ifelse(is.na(cd4_updated),cd4Enrol,cd4_updated))

all_visits$cd4_updated_d <- unsplit(lapply(split(all_visits$cd4_d, all_visits$patient_id), FUN=function(y){
  L <- !is.na(y);y[c(NA,which(L))[cumsum(L)+1]]}),
  all_visits$patient_id)
all_visits$cd4_updated_d<-with(all_visits, ifelse(is.na(cd4_updated_d),as.character(baseline_d),as.character(cd4_updated_d)))


all_visits$init<-with(all_visits,ifelse(is.na(FirstART_d),0,
                                        ifelse(as.Date(FirstART_d)<=as.Date(monthly_date),1,0)))

all_visits$death_d<-as.Date(all_visits$death_d,format="%Y-%m-%d")
all_visits$death_y<-with(all_visits,ifelse(!is.na(as.Date(death_d)), 
                                           ifelse(as.Date(death_d)<=as.Date(monthly_date),1,0),0))



save(all_visits,file="all_visits3-CD4-350.rda")

##Checking monthly dates include l_alive_d for each patient
library("data.table")
tmp <- as.data.table(all_visits) 
summary(tmp[, .SD[.N], by=patient_id]$difaux)
length(unique(all_visits$patient_id))
length(tmp[, .SD[.N], by=patient_id]$difaux)

load("all_visits3-CD4-350.rda")

# all_visits$ADE<-with(all_visits,ifelse(!is.na(as.Date(ce_d)), 
#                                        ifelse(as.Date(ce_d)<=as.Date(monthly_date),1,0),0))

ALL<-all_visits[,c("patient_id","monthly_date", "month","FirstART_d", "birth_d","baseline_d",    
                   "l_alive_d" ,"site", "male", "death_d" , "ce_d",          
                   "cd4" , "cd4_updated", "cd4_updated_d","init", "death_y"            )]

ALL$time.since.cd4<-with(ALL, as.numeric(monthly_date - as.Date(cd4_updated_d)))

save(ALL,file="ALL3-CD4-350.rda")

###### Defining patient time that is consistent with each rule

load("ALL3-CD4-350.rda")

######  Now I'm going to estimate the probability of starting ART given they have not started ART yet.

ALL$age.baseline<-with(ALL, floor(as.numeric((as.Date(baseline_d)-as.Date(birth_d)))/365.25))
ALL$year.baseline<-with(ALL, year(as.Date(baseline_d)))
ALL$fhaart<-with(ALL, ifelse(is.na(FirstART_d),0,
                             ifelse(as.Date(monthly_date)>=as.Date(FirstART_d)&as.Date(monthly_date)-30<as.Date(FirstART_d),1,0)))
sum(ALL$fhaart==1&ALL$init==0)   ###  This should be zero.

ALL$log.month<-log(ALL$month)

stuff<-duplicated(ALL$patient_id)
stuff1<-c(stuff[-1],FALSE)
last<-ifelse(!stuff1,1,0)
ALL$cens<-ifelse(last==1&ALL$death_y==0,1,0)

save(ALL,file="ALL3-CD4-350.rda")
load("ALL3-CD4-350.rda")


remove<-with(ALL, ifelse(fhaart==0 & init==1,1,0))
trt.df<-ALL[remove==0,]
removed<-ALL[remove==1,]
 
# trt.df1<-trt.df[trt.df$month!=1,]
# trt.df1a<-trt.df[trt.df$month==1,]

library(rms)
mod.haart<-glm(fhaart~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site+rcs(year.baseline,4)+rcs(time.since.cd4,4), family="binomial",data=trt.df)  
summary(mod.haart)

mod.haart2<-glm(fhaart~rcs(log.month,4), family="binomial",data=trt.df)  
summary(mod.haart2)

trt.df$pred.trt<-predict(mod.haart,type="response")
trt.df$pred.trt2<-predict(mod.haart2,type="response")

trt.df$p.obs.trt<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt,trt.df$pred.trt)
trt.df$p.obs.trt2<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt2,trt.df$pred.trt2)

trt.df$ratio<-with(trt.df,p.obs.trt2/p.obs.trt)

trt.df$pred.trt<-trt.df$pred.trt2<-trt.df$p.obs.trt<-trt.df$p.obs.trt2<-NULL

removed$ratio<-1

d.new<-rbind(trt.df,removed)
d.new<-d.new[order(d.new$patient_id, d.new$month),]

mod.cens<-glm(cens~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site, family="binomial",data=d.new)  
mod.cens2<-glm(cens~rcs(log.month,4), family="binomial",data=d.new)  
d.new$pred.not.cens<-1-predict(mod.cens,type="response")
d.new$pred.not.cens2<-1-predict(mod.cens2,type="response")
d.new$cens.ratio<-with(d.new,pred.not.cens2/pred.not.cens)
d.new$pred.not.cens<-d.new$pred.not.cens2<-NULL

d.new$sw.cens <- unlist(tapply(d.new$cens.ratio, INDEX=d.new$patient_id, FUN=cumprod))
d.new$sw.trt <- unlist(tapply(d.new$ratio, INDEX=d.new$patient_id, FUN=cumprod))
d.new$sw<-with(d.new, sw.cens*sw.trt)

quantile(d.new$sw, c(0.01,0.025,0.05,.95,.975,.99))

TRUNC.LEVEL1<-0.025
TRUNC.LEVEL2<-0.975
#####  Truncating the weights
w.trunc1<-quantile(d.new$sw,TRUNC.LEVEL1)
w.trunc2<-quantile(d.new$sw,TRUNC.LEVEL2)

d.new$sw.trunc<-ifelse(d.new$sw>w.trunc2,w.trunc2,
                ifelse(d.new$sw<w.trunc1,w.trunc1,d.new$sw))

mod<-glm(death_y~rcs(log.month,4) + init, weights=sw.trunc, data=d.new, family=binomial) 

library(sandwich)
se<-sqrt(sandwich(mod)["init","init"])

hr<-exp(summary(mod)$coeff["init","Estimate"])
lower<-exp(mod$coeff[names(mod$coeff)=="init"]-1.96*se)
upper<-exp(mod$coeff[names(mod$coeff)=="init"]+1.96*se)

ests<-c(hr,lower,upper)
ests

### investigating sensitivity to truncation level
TRUNC.LEVEL1a<-0.01
TRUNC.LEVEL2a<-0.99
w.trunc1a<-quantile(d.new$sw,TRUNC.LEVEL1a)
w.trunc2a<-quantile(d.new$sw,TRUNC.LEVEL2a)
d.new$sw.trunca<-ifelse(d.new$sw>w.trunc2a,w.trunc2a,
                       ifelse(d.new$sw<w.trunc1a,w.trunc1a,d.new$sw))
mod.a<-glm(death_y~rcs(log.month,4) + init, weights=sw.trunca, data=d.new, family=binomial) 
se.a<-sqrt(sandwich(mod.a)["init","init"])
hr.a<-exp(summary(mod.a)$coeff["init","Estimate"])
lower.a<-exp(mod.a$coeff[names(mod.a$coeff)=="init"]-1.96*se.a)
upper.a<-exp(mod.a$coeff[names(mod.a$coeff)=="init"]+1.96*se.a)
ests.99<-c(hr.a,lower.a,upper.a)
ests.99

TRUNC.LEVEL1b<-0.05
TRUNC.LEVEL2b<-0.95
w.trunc1b<-quantile(d.new$sw,TRUNC.LEVEL1b)
w.trunc2b<-quantile(d.new$sw,TRUNC.LEVEL2b)
d.new$sw.truncb<-ifelse(d.new$sw>w.trunc2b,w.trunc2b,
                        ifelse(d.new$sw<w.trunc1b,w.trunc1b,d.new$sw))
mod.b<-glm(death_y~rcs(log.month,4) + init, weights=sw.truncb, data=d.new, family=binomial) 
se.b<-sqrt(sandwich(mod.b)["init","init"])
hr.b<-exp(summary(mod.b)$coeff["init","Estimate"])
lower.b<-exp(mod.b$coeff[names(mod.b$coeff)=="init"]-1.96*se.b)
upper.b<-exp(mod.b$coeff[names(mod.b$coeff)=="init"]+1.96*se.b)
ests.95<-c(hr.b,lower.b,upper.b)
ests.95
###########


mod1<-glm(death_y~rcs(log.month,4) + init*rcs(log.month,4), weights=sw.trunc, data=d.new, family=binomial)#, subset=month<=60) 
summary(mod1)

newdata<-data.frame(month<-rep(c(1:120),2),init<-c(rep(0,120),rep(1,120)))
newdata<-data.frame(log.month<-log(rep(c(1:120),2)),init<-c(rep(0,120),rep(1,120)))
preds<-predict(mod1, newdata=newdata, type="response")
pred.survival.no.art<-unlist(tapply(1-preds, INDEX=newdata$init, FUN=cumprod))[1:120]
pred.survival.art<-unlist(tapply(1-preds, INDEX=newdata$init, FUN=cumprod))[121:240]

######  Model-based plots and results:
plot(c(1:120),pred.survival.no.art, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,60))  #xlim=c(0,120))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.art,col=2)
lines(c(1:120),pred.survival.no.art,col=3)
legend("bottomleft",legend=c("Starting ART","Not Starting ART"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)

(1-pred.survival.no.art[6]-(1-pred.survival.art[6]))/(1-pred.survival.no.art[6])
(1-pred.survival.no.art[12]-(1-pred.survival.art[12]))/(1-pred.survival.no.art[12])
(1-pred.survival.no.art[60]-(1-pred.survival.art[60]))/(1-pred.survival.no.art[60])


prop.init<-NULL
for (i in 1:120) {
  prop.init[i]<-with(d.new,mean(init[month==i]))
}

pred.survival.com<-NULL
for (i in 1:120) {
  pred.survival.com[i]<-pred.survival.art[i]*prop.init[i]+pred.survival.no.art[i]*(1-prop.init[i])
}

######  Model-based plot:
plot(c(1:120),pred.survival.no.art, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,60))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.art,col=2)
lines(c(1:120),pred.survival.com)
lines(c(1:120),pred.survival.no.art,col=3)
legend("bottomleft",legend=c("Starting ART","Not Starting ART","Overall"), 
       lty=c(1,1,1), col=c(2,3,1),bty="n",cex=.8)

((1-pred.survival.com[6])-(1-pred.survival.art[6]))/(1-pred.survival.com[6])
((1-pred.survival.com[12])-(1-pred.survival.art[12]))/(1-pred.survival.com[12])
((1-pred.survival.com[60])-(1-pred.survival.art[60]))/(1-pred.survival.com[60])



######  Empirical plot:  (results are fairly similar to model-based)
s.no.art<-s.art<-s.com<-NULL
s.no.art[1]<-with(d.new, 1-sum(death_y[init==0&month==1])/sum(init==0&month==1))
s.art[1]<-with(d.new, 1-sum(sw.trunc[death_y==1&init==1&month==1])/sum(sw.trunc[init==1&month==1]))
s.com[1]<-with(d.new, 1-sum(death_y==1&month==1)/sum(month==1))
for (i in 2:max(d.new$month)){
  s.no.art[i]<-with(d.new, 1-sum(death_y==1&init==0&month==i)/sum(init==0&month==i))*s.no.art[i-1]
  s.art[i]<-with(d.new, 1-sum(sw.trunc[death_y==1&init==1&month==i])/sum(sw.trunc[init==1&month==i]))*s.art[i-1]
  s.com[i]<-with(d.new, 1-sum(death_y==1&month==i)/sum(month==i))*s.com[i-1]
}

plot(c(1:max(d.new$month)),s.no.art, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,12*5),ylim=c(.3,1))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
box()
lines(c(1:max(d.new$month)),s.art,col=2)
lines(c(1:max(d.new$month)),s.no.art,col=3)
lines(c(1:max(d.new$month)),s.com,col=1)   ###  Why isn't this in the middle of the two?
legend("bottomleft",legend=c("Starting ART","Not Starting ART"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)


((1-s.no.art[6])-(1-s.art[6]))/(1-s.no.art[6])
((1-s.no.art[12])-(1-s.art[12]))/(1-s.no.art[12])
((1-s.no.art[60])-(1-s.art[60]))/(1-s.no.art[60])
((1-s.no.art[120])-(1-s.art[120]))/(1-s.no.art[120])


((1-s.com[6])-(1-s.art[6]))/(1-s.com[6])
((1-s.com[12])-(1-s.art[12]))/(1-s.com[12])
((1-s.com[60])-(1-s.art[60]))/(1-s.com[60])
((1-s.com[120])-(1-s.art[120]))/(1-s.com[120])


#############  


save(ests,ests.99,ests.95,pred.survival.no.art,pred.survival.com,pred.survival.art,s.no.art,s.com,s.art,file="MSM-LP-results-CD4-350.rda")



##################################################################################################################
########  Bootstrapping 
##################################################################################################################

### Start with dataframe "ALL"
unique.ALL<-ALL[!duplicated(ALL$patient_id),]
pids<-factor(unique.ALL$patient_id)

set.seed(20160422)
Nboots<-200
hr.boot<-NULL
pred.survival.art.boot<-pred.survival.no.art.boot<-pred.survival.com.boot<-matrix(NA,Nboots,120)
for (ii in 1:Nboots) {
  
  units<-sample(pids,size=length(pids),replace=TRUE)
  
  ## Sort the units so that you can seqence them
  units <- sort(units)
  
  ## Convert units into the integer repesentation of the factor
  ## so it corrisponds to the index of the pid
  index.units <- as.integer(units)
  
  ## Create a list of row indices grouped by pid.  This list will
  ## ordered according to the order of the pids.
  index.grouped <- split(seq_len(nrow(ALL)), ALL$patient_id)
  
  ## Subset the list of row indices by selected units to
  ## get the indices of the selected units' rows
  index <- unlist(index.grouped[index.units])
  df.boot <- ALL[index, ]
  
  ## Get counts of units to use to create incrementing thing
  ## use integers because integer comparision is faster then
  ## string comparison
  counts <- table(index.units)
  
  ## iterate across counts calling seq_len on each element of counts
  inc <- unlist(lapply(counts, seq_len))
  
  ## determine the number of records each units element has
  chunk.len <- vapply(index.grouped, length, integer(1))
  
  ## subset by units' index to create a vector of number of time each inc needs to be replicated
  rep.times <- chunk.len[index.units]
  
  ## Expand inc by rep.times to create thingy
  boster <- rep(inc, times=rep.times)
  
  df.boot$pid <- paste0(df.boot$pid, '-', boster)
  
  df.boot$patient_id1 <- paste(df.boot$patient_id,df.boot$pid,sep="")
  
  ##  Now I'm inserting my code from above
  
  remove<-with(df.boot, ifelse(fhaart==0 & init==1,1,0))
  trt.df<-df.boot[remove==0,]
  removed<-df.boot[remove==1,]
  
  library(rms)
  mod.haart<-glm(fhaart~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site+rcs(year.baseline,4)+rcs(time.since.cd4,4), family="binomial",data=trt.df)  
  summary(mod.haart)
  
  mod.haart2<-glm(fhaart~rcs(log.month,4), family="binomial",data=trt.df)  
  summary(mod.haart2)
  
  trt.df$pred.trt<-predict(mod.haart,type="response")
  trt.df$pred.trt2<-predict(mod.haart2,type="response")
  
  trt.df$p.obs.trt<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt,trt.df$pred.trt)
  trt.df$p.obs.trt2<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt2,trt.df$pred.trt2)
  
  trt.df$ratio<-with(trt.df,p.obs.trt2/p.obs.trt)
  
  trt.df$pred.trt<-trt.df$pred.trt2<-trt.df$p.obs.trt<-trt.df$p.obs.trt2<-NULL
  
  removed$ratio<-1
  
  d.new<-rbind(trt.df,removed)
  d.new<-d.new[order(d.new$patient_id, d.new$month),]
  
  mod.cens<-glm(cens~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site, family="binomial",data=d.new)  
  mod.cens2<-glm(cens~rcs(log.month,4), family="binomial",data=d.new)  
  d.new$pred.not.cens<-1-predict(mod.cens,type="response")
  d.new$pred.not.cens2<-1-predict(mod.cens2,type="response")
  d.new$cens.ratio<-with(d.new,pred.not.cens2/pred.not.cens)
  d.new$pred.not.cens<-d.new$pred.not.cens2<-NULL
  
  d.new$sw.cens <- unlist(tapply(d.new$cens.ratio, INDEX=d.new$patient_id, FUN=cumprod))
  d.new$sw.trt <- unlist(tapply(d.new$ratio, INDEX=d.new$patient_id, FUN=cumprod))
  d.new$sw<-with(d.new, sw.cens*sw.trt)
  
#   TRUNC.LEVEL1<-.025
#   TRUNC.LEVEL2<-.975
  #####  Truncating the weights
  w.trunc1<-quantile(d.new$sw,TRUNC.LEVEL1)
  w.trunc2<-quantile(d.new$sw,TRUNC.LEVEL2)
  
  d.new$sw.trunc<-ifelse(d.new$sw>w.trunc2,w.trunc2,
                         ifelse(d.new$sw<w.trunc1,w.trunc1,d.new$sw))

  mod<-glm(death_y~rcs(log.month,4) + init, weights=sw.trunc, data=d.new, family=binomial) 

  hr.boot[ii]<-exp(summary(mod)$coeff["init","Estimate"])

  mod1<-glm(death_y~rcs(log.month,4) + init*rcs(log.month,4), weights=sw.trunc, data=d.new, family=binomial)#, subset=month<=60) 
  
  newdata<-data.frame(log.month<-log(rep(c(1:120),2)),init<-c(rep(0,120),rep(1,120)))
  preds<-predict(mod1, newdata=newdata, type="response")
  pred.survival.no.art.boot[ii,]<-unlist(tapply(1-preds, INDEX=newdata$init, FUN=cumprod))[1:120]
  pred.survival.art.boot[ii,]<-unlist(tapply(1-preds, INDEX=newdata$init, FUN=cumprod))[121:240]
  
  
  prop.init<-NULL
  for (i in 1:120) {
    prop.init[i]<-with(d.new,mean(init[month==i]))
    pred.survival.com.boot[ii,i]<-pred.survival.art.boot[ii,i]*prop.init[i]+pred.survival.no.art.boot[ii,i]*(1-prop.init[i])
  }
  
}

###  Bootstrap estimates and 95% CI (very close to original estimates)
mean(hr.boot)
quantile(hr.boot,c(.025,.975))
ests


apply(pred.survival.art.boot, 2, FUN=quantile, .025)
apply(pred.survival.art.boot, 2, FUN=quantile, .975)

apply(pred.survival.no.art.boot, 2, FUN=quantile, .025)
apply(pred.survival.no.art.boot, 2, FUN=quantile, .975)


######  Model-based plots and results:
plot(c(0,120),c(.2,1), type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,60))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.art,col=2)
lines(c(1:120),pred.survival.no.art,col=3)
lines(c(1:120),apply(pred.survival.art.boot, 2, FUN=quantile, .025),col=2,lty=2)
lines(c(1:120),apply(pred.survival.art.boot, 2, FUN=quantile, .975),col=2,lty=2)
lines(c(1:120),apply(pred.survival.no.art.boot, 2, FUN=quantile, .025),col=3,lty=2)
lines(c(1:120),apply(pred.survival.no.art.boot, 2, FUN=quantile, .975),col=3,lty=2)
legend("bottomleft",legend=c("Starting ART","Not Starting ART"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)


(1-pred.survival.no.art[6]-(1-pred.survival.art[6]))/(1-pred.survival.no.art[6])
quantile((1-pred.survival.no.art.boot[,6]-(1-pred.survival.art.boot[,6]))/(1-pred.survival.no.art.boot[,6]),c(.025,.975))

(1-pred.survival.no.art[12]-(1-pred.survival.art[12]))/(1-pred.survival.no.art[12])
quantile((1-pred.survival.no.art.boot[,12]-(1-pred.survival.art.boot[,12]))/(1-pred.survival.no.art.boot[,12]),c(.025,.975))

(1-pred.survival.no.art[60]-(1-pred.survival.art[60]))/(1-pred.survival.no.art[60])
quantile((1-pred.survival.no.art.boot[,60]-(1-pred.survival.art.boot[,60]))/(1-pred.survival.no.art.boot[,60]),c(.025,.975))


((1-pred.survival.com[6])-(1-pred.survival.art[6]))/(1-pred.survival.com[6])
quantile(((1-pred.survival.com.boot[,6])-(1-pred.survival.art.boot[,6]))/(1-pred.survival.com.boot[,6]),c(.025,.975))

((1-pred.survival.com[12])-(1-pred.survival.art[12]))/(1-pred.survival.com[12])
quantile(((1-pred.survival.com.boot[,12])-(1-pred.survival.art.boot[,12]))/(1-pred.survival.com.boot[,12]),c(.025,.975))

((1-pred.survival.com[60])-(1-pred.survival.art[60]))/(1-pred.survival.com[60])
quantile(((1-pred.survival.com.boot[,60])-(1-pred.survival.art.boot[,60]))/(1-pred.survival.com.boot[,60]),c(.025,.975))


save(hr.boot, pred.survival.no.art.boot, pred.survival.art.boot, pred.survival.com.boot, file="MSM-LP-boostrap-results-CD4-350.rda")

