########  This file is the same as 'MSM_creating_monthly_data_mortality.R' except replacing CD4=200 by CD4=350 for late presentation/initiation.

# Creating a monthly data frame for Impact of LHI mortality project
# March 27 2015

#setwd("~/Box Sync/old-laptop/documents/yanin-paco-LHI-2015")
#setwd("C:\Users\vegay\Documents\CCASAnet\Paco_Impact of LHI on mortality")
setwd("C:/Users/vegay/Documents/CCASAnet/Paco_Impact of LHI on mortality/Rev Manuscrito")

#Drop what is in global environment
rm(list=ls())

basic<-read.csv("basic.csv")
cd4<-read.csv("lab_cd4.csv")
rna<-read.csv("lab_rna.csv")
follow<-read.csv("follow.csv",stringsAsFactor=FALSE)
visit<-read.csv("visit.csv")
art<-read.csv("art.csv")
ce<-read.csv("ce.csv")
load("~/CCASAnet/Paco_Impact of LHI on mortality/Rev Manuscrito/basic13D-CD4-350.rda")

basic13E<-basic13D

##### Added by Bryan to grab the date of first CD4<350
cd4$cd4.lt.350<-with(cd4, ifelse(cd4_v<350,1,0))
ord<-with(cd4, order(site, patient_id, as.Date(cd4_d)))
cd4<-cd4[ord,]
cd4<-cd4[!is.na(cd4$cd4_v),]
cd4.lt.350<-cd4[cd4$cd4.lt.350==1&!is.na(cd4$cd4.lt.350),]
junk<-cd4.lt.350[,c("patient_id","site")]
iddup<-duplicated(junk)
head(iddup)
cd4.lt.350.first<-cd4.lt.350[iddup==FALSE,]
cd4.lt.350.first<-cd4.lt.350.first[,c("site","patient_id", "cd4_d","cd4_v","cd4.lt.350")]

basic13E<-merge(basic13E,cd4.lt.350.first,by.x=c("patient_id","site"),by.y=c("patient_id","site"),all.x=TRUE,all.y=FALSE)

#####
basic13E$cutdate<-with(basic13E,ifelse(site=="argentina",as.Date("2014-04-30"),
                                       ifelse(site=="brazil",as.Date("2014-12-16"),
                                              ifelse(site=="chile",as.Date("2014-11-13"),
                                                     ifelse(site=="honduras",as.Date("2014-11-25"),
                                                            ifelse(site=="mexico",as.Date("2014-12-12"),
                                                                   as.Date("2014-07-15")))))))

basic13E$cutdate<-as.Date(basic13E$cutdate,origin="1970-01-01")

basic13E$timetocut<-with(basic13E,as.numeric(cutdate-l_alive_d))

basic13E$ltfu<-with(basic13E,ifelse(death_y==0, 
                                    ifelse(timetocut>365.25,1,0),NA))

exclude<-with(basic13E, ifelse(is.na(LP),1, ifelse(LP==1,1,0)))
table(basic13E[!is.na(basic13E$LP),]$LP)
table(basic13E[!is.na(basic13E$LP),]$LP,basic13E[!is.na(basic13E$LP),]$ltfu)
table(basic13E[!is.na(basic13E$LP)&!is.na(basic13E$FirstART_d),]$LP,basic13E[!is.na(basic13E$LP)&!is.na(basic13E$FirstART_d),]$ltfu)
table(basic13E[!is.na(basic13E$LP)&!is.na(basic13E$FirstART_d)&basic13E$LP==1,]$ltfu)
#2684
table(basic13E[!is.na(basic13E$LP)&is.na(basic13E$FirstART_d)&basic13E$LP==1&basic13E$death_y==0,]$ltfu)
#299
baseMM1<-basic13E[exclude==0,c("site","patient_id","birth_d","baseline_d","hivdiagnosis_d","male",
                               "AIDS_ART","AIDS_Enrol","FirstART_d",
                               "death_d","l_alive_d","death_y","art_class","cd4Enrol",#"cd4HAART"
                               "LP","ce_d","ce_id","cd4_d","cd4_v","cd4.lt.350")]
save(baseMM1,file="baseMM1-CD4-350.rda")

baseMM1$last<-with(baseMM1,as.Date(l_alive_d)+30)
baseMM1$last<-as.Date(baseMM1$last,origin='1970-01-01')

monthly <- lapply(split(baseMM1[,c('patient_id','baseline_d','last')],baseMM1$patient_id),FUN=function(y){
  tmp.seq <- seq(y[,'baseline_d'], y[,'last'], by="month")})
times_per_id <- sapply(monthly, FUN=function(y){length(y)}, simplify=TRUE)

all_visits <- data.frame('patient_id'=rep(names(times_per_id), times=as.numeric(times_per_id)))

all_visits$monthly_date <- unlist(monthly)
all_visits$monthly_date <- as.Date(all_visits$monthly_date, origin='1970-01-01')

all_visits$month <- NA
split(all_visits$month, all_visits$patient_id) <- lapply(split(all_visits[,'patient_id'], all_visits[,'patient_id']),FUN=function(y){
  seq(1,length(y)) })


all_visits$FirstART_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'FirstART_d']
all_visits$birth_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'birth_d']
all_visits$baseline_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'baseline_d']
all_visits$hivdiagnosis_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'hivdiagnosis_d']
all_visits$l_alive_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'l_alive_d']
all_visits$site <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'site']
all_visits$male <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'male']
all_visits$age <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'age']
all_visits$death_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'death_d']
all_visits$cd4Enrol <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4Enrol']
#all_visits$cd4HAART <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4HAART']
#all_visits$cd4Diag <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4Diag']
all_visits$route <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'route']
all_visits$regimen <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'art_class']
all_visits$LP <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'LP']
all_visits$ce_d <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'ce_d']
all_visits$ce_id <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'ce_id']
all_visits$cd4.lt.350_d<-baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4_d']
all_visits$cd4.lt.350<-baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'cd4.lt.350']
#all_visits$survivaltime <- baseMM1[match(all_visits$patient_id, baseMM1$patient_id, nomatch=NA),'survivaltime']

all_visits$id_month<- paste(all_visits$patient_id,all_visits$month,sep='.')


require(lubridate)
ord2<-order(cd4$site,cd4$patient_id,cd4$cd4_d)
cd4<-cd4[ord2,]

cd4$baseline_d<-baseMM1[match(cd4$patient_id,baseMM1$patient_id, nomatch=NA),'baseline_d']
cd4<-cd4[!is.na(cd4$baseline_d),]
cd4$month<-NA
cd4$month<- ceiling((as.numeric(as.Date(cd4$cd4_d))-as.numeric(as.Date(cd4$baseline_d))  )/30)+1 ## +1 added by Bryan
cd4$id_month <- paste(cd4$patient_id,cd4$month,sep='.')

cd4$cd4_new <- NA
split(cd4$cd4_new, cd4$id_month) <- lapply(split(cd4$cd4_v, cd4$id_month), FUN=function(y){
  if(length(y) > 1){
    mean(y,na.rm=TRUE)
  } else {
    y
  } })
cd4 <- subset(cd4, !duplicated(id_month))

all_visits$cd4 <- cd4[match(all_visits$id_month, cd4$id_month,nomatch=NA),'cd4_new']
all_visits$cd4_d <- cd4[match(all_visits$id_month, cd4$id_month,nomatch=NA),'cd4_d']

all_visits$cd4_updated <- unsplit(lapply(split(all_visits$cd4, all_visits$patient_id), FUN=function(y){
  L <- !is.na(y);y[c(NA,which(L))[cumsum(L)+1]]}),
  all_visits$patient_id)
all_visits$cd4_updated<-with(all_visits, ifelse(is.na(cd4_updated),cd4Enrol,cd4_updated))

all_visits$cd4_updated_d <- unsplit(lapply(split(all_visits$cd4_d, all_visits$patient_id), FUN=function(y){
  L <- !is.na(y);y[c(NA,which(L))[cumsum(L)+1]]}),
  all_visits$patient_id)
all_visits$cd4_updated_d<-with(all_visits, ifelse(is.na(cd4_updated_d),as.character(baseline_d),as.character(cd4_updated_d)))


all_visits$init<-with(all_visits,ifelse(is.na(FirstART_d),0,
                                        ifelse(as.Date(FirstART_d)<=as.Date(monthly_date),1,0)))

all_visits$death_d<-as.Date(all_visits$death_d,format="%Y-%m-%d")
all_visits$death_y<-with(all_visits,ifelse(!is.na(as.Date(death_d)), 
                                           ifelse(as.Date(death_d)<=as.Date(monthly_date),1,0),0))



save(all_visits,file="all_visits-CD4-350.rda")

##Checking monthly dates include l_alive_d for each patient
library("data.table")
tmp <- as.data.table(all_visits)
summary(tmp[, .SD[.N], by=patient_id]$difaux)
length(unique(all_visits$patient_id))
length(tmp[, .SD[.N], by=patient_id]$difaux)

load("all_visits-CD4-350.rda")

all_visits$ADE<-with(all_visits,ifelse(!is.na(as.Date(ce_d)), 
                                       ifelse(as.Date(ce_d)<=as.Date(monthly_date),1,0),0))

all_visits$CD4.lt.350<-with(all_visits,ifelse(!is.na(as.Date(cd4.lt.350_d)),
                                              ifelse(as.Date(cd4.lt.350_d)<=as.Date(monthly_date),1,0),0))
ALL<-all_visits[,c("patient_id","monthly_date", "month","FirstART_d", "birth_d","baseline_d",    
                   "l_alive_d" ,"site", "male", "death_d" , "ce_d","cd4.lt.350_d",          
                   "cd4" , "cd4_updated", "cd4_updated_d","init", "death_y" , "ADE","CD4.lt.350"           )]

ALL$time.since.cd4<-with(ALL, as.numeric(monthly_date - as.Date(cd4_updated_d)))

save(ALL,file="ALL-CD4-350.rda")

###### Defining patient time that is consistent with each rule

load("ALL-CD4-350.rda")

ALL$ADV<-with(ALL, ifelse(CD4.lt.350 | ADE==1, 1,0 ))
ALL$ADV_d<-with(ALL, ifelse(is.na(ce_d)&is.na(cd4.lt.350_d),NA,
                            ifelse(!is.na(ce_d)&is.na(cd4.lt.350_d),as.character(ce_d),
                                   ifelse(is.na(ce_d)&!is.na(cd4.lt.350_d),as.character(cd4.lt.350_d),
                                          ifelse(as.Date(ce_d)<as.Date(cd4.lt.350_d),as.character(ce_d),as.character(cd4.lt.350_d))))))

ALL$rule1<-with(ALL, ifelse(init==0&ADV==0,1,
                            ifelse(init==0&ADV==1,0,
                                   ifelse(init==1&ADV==0,1,
                                          ifelse(init==1&ADV==1&as.Date(FirstART_d)<as.Date(ADV_d),1,
                                                 ifelse(init==1&ADV==1&as.Date(FirstART_d)>=as.Date(ADV_d),0,999))))))

ALL$rule2<-with(ALL, ifelse(init==0&ADV==0,1,
                            ifelse(init==0&ADV==1,1,
                                   ifelse(init==1&ADV==0,0,
                                          ifelse(init==1&ADV==1&as.Date(FirstART_d)<as.Date(ADV_d),0,
                                                 ifelse(init==1&ADV==1&as.Date(FirstART_d)>=as.Date(ADV_d),1,999))))))

######  Now I'm going to estimate the probability of starting ART given they have not started ART yet.

ALL$age.baseline<-with(ALL, floor(as.numeric((as.Date(baseline_d)-as.Date(birth_d)))/365.25))
ALL$year.baseline<-with(ALL, year(as.Date(baseline_d)))
ALL$fhaart<-with(ALL, ifelse(is.na(FirstART_d),0,
                             ifelse(as.Date(monthly_date)>=as.Date(FirstART_d)&as.Date(monthly_date)-30<as.Date(FirstART_d),1,0)))
sum(ALL$fhaart==1&ALL$init==0)   ###  This should be zero.

cd4.updated.lag<-c(NA,ALL$cd4_updated[-length(ALL$cd4_updated)])
ALL$cd4.updated.lag<-with(ALL,ifelse(duplicated(ALL$patient_id),cd4.updated.lag,NA))

ALL$log.month<-log(ALL$month)

stuff<-duplicated(ALL$patient_id)
stuff1<-c(stuff[-1],FALSE)
last<-ifelse(!stuff1,1,0)
ALL$cens<-ifelse(last==1&ALL$death_y==0,1,0)

save(ALL,file="ALL-CD4-350.rda")
load("ALL-CD4-350.rda")

library(rms)

mod.cens<-glm(cens~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site, family="binomial",data=ALL)  
mod.cens2<-glm(cens~rcs(log.month,4), family="binomial",data=ALL)  
ALL$pred.not.cens<-1-predict(mod.cens,type="response")
ALL$pred.not.cens2<-1-predict(mod.cens2,type="response")
ALL$ipc<-with(ALL,pred.not.cens2/pred.not.cens)
ALL$pred.not.cens<-ALL$pred.not.cens2<-NULL

ALL$ipcw <- unlist(tapply(ALL$ipc, INDEX=ALL$patient_id, FUN=cumprod))


remove<-with(ALL, ifelse(fhaart==0 & init==1,1,0))
trt.df<-ALL[remove==0,]
removed<-ALL[remove==1,]

trt.df1<-trt.df[trt.df$month!=1,]
trt.df1a<-trt.df[trt.df$month==1,]

mod.haart<-glm(fhaart~rcs(log.month,4)+rcs(cd4_updated,4)+rcs(age.baseline,4)+male+site+rcs(year.baseline,4)+rcs(time.since.cd4,4), family="binomial",data=trt.df1)  
summary(mod.haart)

trt.df1$pred.trt<-predict(mod.haart,type="response")
trt.df1a$pred.trt<-0
trt.df2<-rbind(trt.df1,trt.df1a)
trt.df<-trt.df2[order(trt.df2$patient_id, trt.df2$month),]
trt.df$p.obs.trt<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt,trt.df$pred.trt)

removed$pred.trt<-removed$p.obs.trt<-NA

d.new<-rbind(trt.df,removed)
d.new<-d.new[order(d.new$patient_id, d.new$month),]

d.new$p.obs.trt2<-with(d.new, ifelse(is.na(p.obs.trt),1,p.obs.trt))

d.new$p.obs.trt2a<-with(d.new, ifelse(ADV==1,1,p.obs.trt2))  ## A patient cannot be censored from defer arm if they have ADV=1

d.new$w.def2<-with(d.new, 1/p.obs.trt2a)

d.new$w.def <- unlist(tapply(d.new$w.def2, INDEX=d.new$patient_id, FUN=cumprod))

d.new.def<-d.new[d.new$rule2==1,]
d.new.def$defer<-1
d.new.def$weight<-d.new.def$w.def


d.new.def$cd4.updated.lag<-d.new.def$pred.trt<-d.new.def$p.obs.trt<-d.new.def$p.obs.trt2<-d.new.def$p.obs.trt2a<-d.new.def$w.def2<-d.new.def$w.def<-NULL

d.new.imm<-d.new[d.new$rule1==1,]
#d.new.imm$weight<-1
d.new.imm$defer<-0

d.new.imm$cd4.updated.lag<-d.new.imm$pred.trt<-d.new.imm$p.obs.trt<-d.new.imm$p.obs.trt2<-d.new.imm$p.obs.trt2a<-d.new.imm$w.def2<-d.new.imm$w.def<-NULL


############  NEW STUFF (11/10/15) ################
####  Now adding in weights for the probability of disease stage becoming advanced without starting treatment.

keep.ADV<-with(ALL, ifelse(init==0 & ADV==0,1,0))
ADV.df<-ALL[keep.ADV==1,]
removed.ADV<-ALL[keep.ADV==0,]
stuff<-with(removed.ADV, ifelse(init==0 & ADV==1, TRUE, FALSE))
removed.ADV.1<-removed.ADV[stuff,]
removed.ADV.1<-removed.ADV.1[order(removed.ADV.1$patient_id, removed.ADV.1$month),]
removed.ADV.2<-removed.ADV.1[!duplicated(removed.ADV.1$patient_id),]
removed.ADV.2$add.ADV<-NULL
ADV.df1<-rbind(ADV.df,removed.ADV.2)
ADV.df1<-ADV.df1[order(ADV.df1$patient_id, ADV.df1$month),]
ADV.df2<-ADV.df1[ADV.df1$month!=1,]
ADV.df2a<-ADV.df1[ADV.df1$month==1,]

mod.ADV<-glm(ADV~rcs(log.month,4)+rcs(cd4.updated.lag,4)+rcs(age.baseline,4)+male+site+rcs(year.baseline,4)+rcs(time.since.cd4,4), 
             family="binomial",data=ADV.df2)  
summary(mod.ADV)

ADV.df2$pred.ADV<-predict(mod.ADV,type="response")
ADV.df2a$pred.ADV<-0
ADV.df3<-rbind(ADV.df2,ADV.df2a)
ADV.df3<-ADV.df3[order(ADV.df3$patient_id, ADV.df3$month),]

ADV.df3$p.obs.ADV<-ifelse(ADV.df3$ADV==0,1-ADV.df3$pred.ADV,NA)
ADV.df4<-ADV.df3[!is.na(ADV.df3$p.obs.ADV),]

ADV.df4$w.def2<-with(ADV.df4, 1/p.obs.ADV)



#ADV.df4$w.def <- unlist(tapply(ADV.df4$w.def2, INDEX=ADV.df4$patient_id, FUN=cumprod))

ADV.df5<-ADV.df4[,c("patient_id","month","w.def2")]

d.new.imm1<-merge(d.new.imm,ADV.df5,by=c("patient_id","month"),all.x=TRUE)
d.new.imm1$w.def2<-with(d.new.imm1, ifelse(is.na(w.def2),1,w.def2))
d.new.imm1<-d.new.imm1[order(d.new.imm1$patient_id,d.new.imm1$month),]

d.new.imm1$weight <- unlist(tapply(d.new.imm1$w.def2, INDEX=d.new.imm1$patient_id, FUN=cumprod))
d.new.imm1$w.def2<-NULL


d.analysis<-rbind(d.new.def,d.new.imm1)

sum(d.analysis$death_y)
sum(ALL$death_y)      ### These should not be the same unless no patient died with CD4>350/no AIDS and not on ART

d.analysis$weight<-with(d.analysis, ipcw*weight)

summary(d.analysis$weight)
summary(d.analysis$weight[d.analysis$defer==1])
quantile(d.analysis$weight, c(.95,.975,.99))

TRUNC.LEVEL2<-.975
TRUNC.LEVEL1<-.025
#####  Truncating the weights
w.trunc2<-quantile(d.analysis$weight,TRUNC.LEVEL2)
w.trunc1<-quantile(d.analysis$weight,TRUNC.LEVEL1)
d.analysis$weight.trunc<-ifelse(d.analysis$weight>w.trunc2,w.trunc2,
                                ifelse(d.analysis$weight<w.trunc1,w.trunc1,d.analysis$weight))

with(d.analysis, table(defer, death_y))
with(d.analysis, mean(death_y[defer==0]))
with(d.analysis, mean(death_y[defer==1]))
chisq.test(with(d.analysis, table(defer, death_y)))

mod<-glm(death_y~rcs(log.month,4) + defer, weights=weight.trunc, data=d.analysis, family=binomial) 
#mod<-glm(death_y~defer, data=d.analysis, family=binomial) 

library(sandwich)
se<-sqrt(sandwich(mod)["defer","defer"])

hr<-exp(summary(mod)$coeff["defer","Estimate"])
lower<-exp(mod$coeff[names(mod$coeff)=="defer"]-1.96*se)
upper<-exp(mod$coeff[names(mod$coeff)=="defer"]+1.96*se)

ests<-c(hr,lower,upper)
ests

#####  Sensitivity of results to truncation level
TRUNC.LEVEL2a<-.99
TRUNC.LEVEL1a<-.01
w.trunc2a<-quantile(d.analysis$weight,TRUNC.LEVEL2a)
w.trunc1a<-quantile(d.analysis$weight,TRUNC.LEVEL1a)
d.analysis$weight.trunca<-ifelse(d.analysis$weight>w.trunc2a,w.trunc2a,
                                 ifelse(d.analysis$weight<w.trunc1a,w.trunc1a,d.analysis$weight))
mod.a<-glm(death_y~rcs(log.month,4) + defer, weights=weight.trunca, data=d.analysis, family=binomial) 
se.a<-sqrt(sandwich(mod.a)["defer","defer"])
hr.a<-exp(summary(mod.a)$coeff["defer","Estimate"])
lower.a<-exp(mod.a$coeff[names(mod.a$coeff)=="defer"]-1.96*se.a)
upper.a<-exp(mod.a$coeff[names(mod.a$coeff)=="defer"]+1.96*se.a)
ests.99<-c(hr.a,lower.a,upper.a)
ests.99

TRUNC.LEVEL2b<-.95
TRUNC.LEVEL1b<-.05
w.trunc2b<-quantile(d.analysis$weight,TRUNC.LEVEL2b)
w.trunc1b<-quantile(d.analysis$weight,TRUNC.LEVEL1b)
d.analysis$weight.truncb<-ifelse(d.analysis$weight>w.trunc2b,w.trunc2b,
                                 ifelse(d.analysis$weight<w.trunc1b,w.trunc1b,d.analysis$weight))
mod.b<-glm(death_y~rcs(log.month,4) + defer, weights=weight.truncb, data=d.analysis, family=binomial) 
se.b<-sqrt(sandwich(mod.b)["defer","defer"])
hr.b<-exp(summary(mod.b)$coeff["defer","Estimate"])
lower.b<-exp(mod.b$coeff[names(mod.b$coeff)=="defer"]-1.96*se.b)
upper.b<-exp(mod.b$coeff[names(mod.b$coeff)=="defer"]+1.96*se.b)
ests.95<-c(hr.b,lower.b,upper.b)
ests.95

#mod1<-glm(death_y~rcs(log.month,4) + defer*rcs(log.month,4), weights=weight.trunc, data=d.analysis, family=binomial)   ## Not enough data/events to fit this model
mod1<-glm(death_y~ns(log.month,3) + defer + defer:log.month, weights=weight.trunc, data=d.analysis, family=binomial) 
#mod1a<-glm(death_y~rcs(log.month,4) + defer, weights=weight.trunc, data=d.analysis, family=binomial) 
#anova(mod1a,mod1)
summary(mod1)


newdata<-data.frame(log.month<-log(rep(c(1:120),2)),defer<-c(rep(0,120),rep(1,120)))
preds<-predict(mod1, newdata=newdata, type="response")
pred.survival.imm<-unlist(tapply(1-preds, INDEX=newdata$defer, FUN=cumprod))[1:120]
pred.survival.def<-unlist(tapply(1-preds, INDEX=newdata$defer, FUN=cumprod))[121:240]

######  Model-based plots and results:
plot(c(1:120),pred.survival.def, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,120))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.imm,col=2)
lines(c(1:120),pred.survival.def,col=3)
legend("bottomleft",legend=c("Start ART while CD4>=350 and no ADE","Defer ART until CD4<350 or ADE"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)

(1-pred.survival.def[12]-(1-pred.survival.imm[12]))/(1-pred.survival.def[12])
(1-pred.survival.def[60]-(1-pred.survival.imm[60]))/(1-pred.survival.def[60])
(1-pred.survival.def[120]-(1-pred.survival.imm[120]))/(1-pred.survival.def[120])

prop.defer<-NULL
for (i in 1:120) {
  prop.defer[i]<-with(d.analysis,mean(defer[month==i]))
}

pred.survival.com<-NULL
for (i in 1:120) {
  pred.survival.com[i]<-pred.survival.def[i]*prop.defer[i]+pred.survival.imm[i]*(1-prop.defer[i])
}

######  Model-based plot:
plot(c(1:120),pred.survival.def, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,120))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.imm,col=2)
lines(c(1:120),pred.survival.com)
lines(c(1:120),pred.survival.def,col=3)
legend("bottomleft",legend=c("Start ART while CD4>=350 and no ADE","Defer ART until CD4<350 or ADE","Overall"), 
       lty=c(1,1,1), col=c(2,3,1),bty="n",cex=.8)

((1-pred.survival.com[12])-(1-pred.survival.imm[12]))/(1-pred.survival.com[12])
((1-pred.survival.com[60])-(1-pred.survival.imm[60]))/(1-pred.survival.com[60])
((1-pred.survival.com[120])-(1-pred.survival.imm[120]))/(1-pred.survival.com[120])



######  Empirical plot:  (results are fairly similar to model-based)
s.def<-s.imm<-s.com<-NULL
s.imm[1]<-with(d.analysis, 1-sum(death_y[defer==0&month==1])/sum(defer==0&month==1))
s.def[1]<-with(d.analysis, 1-sum(weight.trunc[death_y==1&defer==1&month==1])/sum(weight.trunc[defer==1&month==1]))
s.com[1]<-with(d.analysis, 1-sum(death_y==1&month==1)/sum(month==1))
for (i in 2:max(d.analysis$month)){
  s.imm[i]<-with(d.analysis, 1-sum(death_y==1&defer==0&month==i)/sum(defer==0&month==i))*s.imm[i-1]
  s.def[i]<-with(d.analysis, 1-sum(weight.trunc[death_y==1&defer==1&month==i])/sum(weight.trunc[defer==1&month==i]))*s.def[i-1]
  s.com[i]<-with(d.analysis, 1-sum(death_y==1&month==i)/sum(month==i))*s.com[i-1]
}

plot(c(1:max(d.analysis$month)),s.def, type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,12*10),ylim=c(.92,1))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
box()
lines(c(1:max(d.analysis$month)),s.imm,col=2)
lines(c(1:max(d.analysis$month)),s.def,col=3)
#lines(c(1:max(d.analysis$month)),s.com,col=1)   ###  Why isn't this in the middle of the two?
legend("bottomleft",legend=c("Start ART while CD4>=350 and no ADE","Defer ART until CD4<350 or ADE"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)


((1-s.def[6])-(1-s.imm[6]))/(1-s.def[6])
((1-s.def[12])-(1-s.imm[12]))/(1-s.def[12])
((1-s.def[60])-(1-s.imm[60]))/(1-s.def[60])
((1-s.def[120])-(1-s.imm[120]))/(1-s.def[120])

#####  These numbers do not make much sense:
((1-s.com[6])-(1-s.imm[6]))/(1-s.com[6])
((1-s.com[12])-(1-s.imm[12]))/(1-s.com[12])
((1-s.com[60])-(1-s.imm[60]))/(1-s.com[60])
((1-s.com[120])-(1-s.imm[120]))/(1-s.com[120])


####  Only 18% of patients started in an advanced disease stage
with(ALL, summary(ADV[fhaart==1]))



#####  Calculating the numbers of patients in different groups 

dup<-duplicated(ALL$patient_id)
unique.ALL<-ALL[!dup,]
started.not.ADV<-with(unique.ALL, ifelse(!is.na(FirstART_d) & is.na(ADV_d),1,
                                         ifelse(!is.na(FirstART_d) & as.Date(FirstART_d)< as.Date(ADV_d),1,0)))
started.ADV<-with(unique.ALL, ifelse(!is.na(FirstART_d) & !is.na(ADV_d) & as.Date(FirstART_d)>=as.Date(ADV_d),1,0))
never.started.not.ADV<-with(unique.ALL, ifelse(is.na(FirstART_d) & is.na(ADV_d),1,0))
never.started.ADV<-with(unique.ALL, ifelse(is.na(FirstART_d) & !is.na(ADV_d),1,0))

sum(started.not.ADV)
sum(started.ADV)
sum(never.started.not.ADV)
sum(never.started.ADV)

group.df<-data.frame(patient_id=unique.ALL$patient_id,started.not.ADV,started.ADV,never.started.not.ADV,never.started.ADV)
counting.df<-merge(ALL,group.df,by.x="patient_id",by.y="patient_id")
sum(ALL$death_y)
sum(counting.df$death_y)

with(counting.df, sum(death_y[started.not.ADV==1]))
with(counting.df, sum(death_y[started.ADV==1]))
with(counting.df, sum(death_y[never.started.not.ADV==1]))
with(counting.df, sum(death_y[never.started.ADV==1]))

with(counting.df, sum(death_y[started.not.ADV==1]))/sum(started.not.ADV)
with(counting.df, sum(death_y[started.ADV==1]))/sum(started.ADV)
with(counting.df, sum(death_y[never.started.not.ADV==1]))/sum(never.started.not.ADV)
with(counting.df, sum(death_y[never.started.ADV==1]))/sum(never.started.ADV)

save(ests,ests.99,ests.95,pred.survival.def,pred.survival.com,pred.survival.imm,s.def,s.com,s.imm,file="dMSM-results-CD4-350.rda")

##Merge info from LTFU with unique ALL
AUX<-basic13E[!is.na(basic13E$LP)&exclude==0,c('patient_id','ltfu')]
AUX2<-merge(unique.ALL,AUX,by=c('patient_id'),all.x=TRUE,all.y=FALSE)

group.df$ltfu<-AUX2[match(group.df$patient_id,AUX2$patient_id,nomatch=NA),'ltfu']

table(group.df[group.df$started.ADV==1, ]$ltfu)
table(group.df[group.df$started.not.ADV==1, ]$ltfu)
table(group.df[group.df$never.started.ADV==1, ]$ltfu)
table(group.df[group.df$never.started.not.ADV==1, ]$ltfu)


##################################################################################################################
########  Bootstrapping 
##################################################################################################################

### Start with dataframe "ALL"
pids<-factor(unique.ALL$patient_id)

set.seed(20151117)
Nboots<-100
hr.boot<-NULL
pred.survival.imm.boot<-pred.survival.def.boot<-pred.survival.com.boot<-matrix(NA,Nboots,120)
for (ii in 1:Nboots) {
  
  units<-sample(pids,size=length(pids),replace=TRUE)
  
  ## Sort the units so that you can seqence them
  units <- sort(units)
  
  ## Convert units into the integer repesentation of the factor
  ## so it corrisponds to the index of the pid
  index.units <- as.integer(units)
  
  ## Create a list of row indices grouped by pid.  This list will
  ## ordered according to the order of the pids.
  index.grouped <- split(seq_len(nrow(ALL)), ALL$patient_id)
  
  ## Subset the list of row indices by selected units to
  ## get the indices of the selected units' rows
  index <- unlist(index.grouped[index.units])
  df.boot <- ALL[index, ]
  
  ## Get counts of units to use to create incrementing thing
  ## use integers because integer comparision is faster then
  ## string comparison
  counts <- table(index.units)
  
  ## iterate across counts calling seq_len on each element of counts
  inc <- unlist(lapply(counts, seq_len))
  
  ## determine the number of records each units element has
  chunk.len <- vapply(index.grouped, length, integer(1))
  
  ## subset by units' index to create a vector of number of time each inc needs to be replicated
  rep.times <- chunk.len[index.units]
  
  ## Expand inc by rep.times to create thingy
  boster <- rep(inc, times=rep.times)
  
  df.boot$pid <- paste0(df.boot$pid, '-', boster)
  
  df.boot$patient_id1 <- paste(df.boot$patient_id,df.boot$pid,sep="")
  
  ##  Now I'm inserting my code from above
  
  mod.cens<-glm(cens~ns(log.month,3)+ns(cd4_updated,3)+ns(age.baseline,3)+male+site, family="binomial",data=df.boot)  
  mod.cens2<-glm(cens~ns(log.month,3), family="binomial",data=df.boot)  
  df.boot$pred.not.cens<-1-predict(mod.cens,type="response")
  df.boot$pred.not.cens2<-1-predict(mod.cens2,type="response")
  df.boot$ipc<-with(df.boot,pred.not.cens2/pred.not.cens)
  df.boot$pred.not.cens<-df.boot$pred.not.cens2<-NULL
  df.boot$ipcw <- unlist(tapply(df.boot$ipc, INDEX=df.boot$patient_id, FUN=cumprod))
  
  remove<-with(df.boot, ifelse(fhaart==0 & init==1,1,0))
  trt.df<-df.boot[remove==0,]
  removed<-df.boot[remove==1,]
  
  trt.df1<-trt.df[trt.df$month!=1,]
  trt.df1a<-trt.df[trt.df$month==1,]
  
  mod.haart<-glm(fhaart~ns(log.month,3)+ns(cd4_updated,3)+ns(age.baseline,3)+male+site+ns(year.baseline,3)+ns(time.since.cd4,3), family="binomial",data=trt.df1)  
  
  trt.df1$pred.trt<-predict(mod.haart,type="response")
  trt.df1a$pred.trt<-0
  trt.df2<-rbind(trt.df1,trt.df1a)
  trt.df<-trt.df2[order(trt.df2$patient_id1, trt.df2$month),]
  trt.df$p.obs.trt<-ifelse(trt.df$fhaart==0,1-trt.df$pred.trt,trt.df$pred.trt)
  
  removed$pred.trt<-removed$p.obs.trt<-NA
  
  d.new<-rbind(trt.df,removed)
  d.new<-d.new[order(d.new$patient_id1, d.new$month),]
  
  d.new$p.obs.trt2<-with(d.new, ifelse(is.na(p.obs.trt),1,p.obs.trt))
  d.new$p.obs.trt2a<-with(d.new, ifelse(ADV==1,1,p.obs.trt2))  ## A patient cannot be censored from defer arm if they have ADV=1
  d.new$w.def2<-with(d.new, 1/p.obs.trt2a)
  d.new$w.def <- unlist(tapply(d.new$w.def2, INDEX=d.new$patient_id1, FUN=cumprod))
  
  d.new.def<-d.new[d.new$rule2==1,]
  d.new.def$defer<-1
  d.new.def$weight<-d.new.def$w.def
  d.new.def$cd4.updated.lag<-d.new.def$pred.trt<-d.new.def$p.obs.trt<-d.new.def$p.obs.trt2<-d.new.def$p.obs.trt2a<-d.new.def$w.def2<-d.new.def$w.def<-NULL
  
  d.new.imm<-d.new[d.new$rule1==1,]
  d.new.imm$defer<-0
  d.new.imm$cd4.updated.lag<-d.new.imm$pred.trt<-d.new.imm$p.obs.trt<-d.new.imm$p.obs.trt2<-d.new.imm$p.obs.trt2a<-d.new.imm$w.def2<-d.new.imm$w.def<-NULL
  
  keep.ADV<-with(df.boot, ifelse(init==0 & ADV==0,1,0))
  ADV.df<-df.boot[keep.ADV==1,]
  removed.ADV<-df.boot[keep.ADV==0,]
  stuff<-with(removed.ADV, ifelse(init==0 & ADV==1, TRUE, FALSE))
  removed.ADV.1<-removed.ADV[stuff,]
  removed.ADV.1<-removed.ADV.1[order(removed.ADV.1$patient_id1, removed.ADV.1$month),]
  removed.ADV.2<-removed.ADV.1[!duplicated(removed.ADV.1$patient_id1),]
  removed.ADV.2$add.ADV<-NULL
  ADV.df1<-rbind(ADV.df,removed.ADV.2)
  ADV.df1<-ADV.df1[order(ADV.df1$patient_id1, ADV.df1$month),]
  ADV.df2<-ADV.df1[ADV.df1$month!=1,]
  ADV.df2a<-ADV.df1[ADV.df1$month==1,]
  
  mod.ADV<-glm(ADV~ns(log.month,3)+ns(cd4.updated.lag,3)+ns(age.baseline,3)+male+site+ns(year.baseline,3)+ns(time.since.cd4,3), 
               family="binomial",data=ADV.df2)  
  
  ADV.df2$pred.ADV<-predict(mod.ADV,type="response")
  ADV.df2a$pred.ADV<-0
  ADV.df3<-rbind(ADV.df2,ADV.df2a)
  ADV.df3<-ADV.df3[order(ADV.df3$patient_id1, ADV.df3$month),]
  
  ADV.df3$p.obs.ADV<-ifelse(ADV.df3$ADV==0,1-ADV.df3$pred.ADV,NA)
  ADV.df4<-ADV.df3[!is.na(ADV.df3$p.obs.ADV),]
  
  ADV.df4$w.def2<-with(ADV.df4, 1/p.obs.ADV)
  ADV.df5<-ADV.df4[,c("patient_id1","month","w.def2")]
  
  d.new.imm1<-merge(d.new.imm,ADV.df5,by=c("patient_id1","month"),all.x=TRUE)
  d.new.imm1$w.def2<-with(d.new.imm1, ifelse(is.na(w.def2),1,w.def2))
  d.new.imm1<-d.new.imm1[order(d.new.imm1$patient_id1,d.new.imm1$month),]
  
  d.new.imm1$weight <- unlist(tapply(d.new.imm1$w.def2, INDEX=d.new.imm1$patient_id1, FUN=cumprod))
  d.new.imm1$w.def2<-NULL
  
  d.analysis<-rbind(d.new.def,d.new.imm1)
  
  d.analysis$weight<-with(d.analysis, ipcw*weight)
  
  TRUNC.LEVEL2<-.975
  TRUNC.LEVEL1<-.025
  #####  Truncating the weights
  w.trunc2<-quantile(d.analysis$weight,TRUNC.LEVEL2)
  w.trunc1<-quantile(d.analysis$weight,TRUNC.LEVEL1)
  d.analysis$weight.trunc<-ifelse(d.analysis$weight>w.trunc2,w.trunc2,
                                  ifelse(d.analysis$weight<w.trunc1,w.trunc1,d.analysis$weight))
  
  mod<-glm(death_y~ns(log.month,3) + defer, weights=weight.trunc, data=d.analysis, family=binomial) 
  
  hr.boot[ii]<-exp(summary(mod)$coeff["defer","Estimate"])
  
  mod1<-glm(death_y~ns(log.month,3) + defer + defer:log.month, weights=weight.trunc, data=d.analysis, family=binomial) 
  
  newdata<-data.frame(log.month<-log(rep(c(1:120),2)),defer<-c(rep(0,120),rep(1,120)))
  preds<-predict(mod1, newdata=newdata, type="response")
  pred.survival.imm.boot[ii,]<-unlist(tapply(1-preds, INDEX=newdata$defer, FUN=cumprod))[1:120]
  pred.survival.def.boot[ii,]<-unlist(tapply(1-preds, INDEX=newdata$defer, FUN=cumprod))[121:240]
  
  prop.defer<-NULL
  for (i in 1:120) {
    prop.defer[i]<-with(d.analysis,mean(defer[month==i]))
    pred.survival.com.boot[ii,i]<-pred.survival.def.boot[ii,i]*prop.defer[i]+pred.survival.imm.boot[ii,i]*(1-prop.defer[i])
  }
  
}

###  Bootstrap estimates and 95% CI (very close to original estimates)
mean(hr.boot)
quantile(hr.boot,c(.025,.975))
ests


apply(pred.survival.imm.boot, 2, FUN=quantile, .025)
apply(pred.survival.imm.boot, 2, FUN=quantile, .975)

apply(pred.survival.def.boot, 2, FUN=quantile, .025)
apply(pred.survival.def.boot, 2, FUN=quantile, .975)


######  Model-based plots and results:
plot(c(0,120),c(.88,1), type="n", xlab="Years since enrollment", ylab="Survival probability",axes=FALSE,xlim=c(0,120))
axis(2)
axis(1, at=c(0:10)*12, label=c(0:10))
lines(c(1:120),pred.survival.imm,col=2)
lines(c(1:120),pred.survival.def,col=3)
lines(c(1:120),apply(pred.survival.imm.boot, 2, FUN=quantile, .025),col=2,lty=2)
lines(c(1:120),apply(pred.survival.imm.boot, 2, FUN=quantile, .975),col=2,lty=2)
lines(c(1:120),apply(pred.survival.def.boot, 2, FUN=quantile, .025),col=3,lty=2)
lines(c(1:120),apply(pred.survival.def.boot, 2, FUN=quantile, .975),col=3,lty=2)
legend("bottomleft",legend=c("Start ART while CD4>=350 and no ADE","Defer ART until CD4<350 or ADE"), 
       lty=c(1,1), col=c(2,3),bty="n",cex=.8)

(1-pred.survival.def[12]-(1-pred.survival.imm[12]))/(1-pred.survival.def[12])
quantile((1-pred.survival.def.boot[,12]-(1-pred.survival.imm.boot[,12]))/(1-pred.survival.def.boot[,12]),c(.025,.975))

(1-pred.survival.def[60]-(1-pred.survival.imm[60]))/(1-pred.survival.def[60])
quantile((1-pred.survival.def.boot[,60]-(1-pred.survival.imm.boot[,60]))/(1-pred.survival.def.boot[,60]),c(.025,.975))

(1-pred.survival.def[120]-(1-pred.survival.imm[120]))/(1-pred.survival.def[120])
quantile((1-pred.survival.def.boot[,120]-(1-pred.survival.imm.boot[,120]))/(1-pred.survival.def.boot[,120]),c(.025,.975))


((1-pred.survival.com[12])-(1-pred.survival.imm[12]))/(1-pred.survival.com[12])
quantile(((1-pred.survival.com.boot[,12])-(1-pred.survival.imm.boot[,12]))/(1-pred.survival.com.boot[,12]),c(.025,.975))

((1-pred.survival.com[60])-(1-pred.survival.imm[60]))/(1-pred.survival.com[60])
quantile(((1-pred.survival.com.boot[,60])-(1-pred.survival.imm.boot[,60]))/(1-pred.survival.com.boot[,60]),c(.025,.975))

((1-pred.survival.com[120])-(1-pred.survival.imm[120]))/(1-pred.survival.com[120])
quantile(((1-pred.survival.com.boot[,120])-(1-pred.survival.imm.boot[,120]))/(1-pred.survival.com.boot[,120]),c(.025,.975))


save(hr.boot, pred.survival.def.boot, pred.survival.imm.boot, pred.survival.com.boot, file="dMSM-boostrap-results-CD4-350.rda")


load("~/CCASAnet/Paco_Impact of LHI on mortality/Rev Manuscrito/ALL-CD4-350.rda")

