#########  These scripts repeat the selection_2015-04-23.R scripts, except CD4=200 has been replaced by CD4=350.
####     2016-04-22 (one year later!)

#January 14/2015
#CCASAnet Project: Impact of late testing and late presentation on mortality among HIV-infected adults 
#receiving care in Latin America
#Leader: Paco

##March 27/2015
##Updated concept sheet: We will answer 2 specific questions: 1.  What is the impact on mortality of 
#presenting to care with CD4<350 (or an ADE at enrolment)?
#2.	Among those who present to care with CD4>350, what is the impact on mortality of delaying initiation 
#of ART to CD4<350?
##All HIV-infected patients starting follow-up, na?ve to ART in all CCASAnet sites between 2001-2014.



setwd("~/Box Sync/old-laptop/documents/yanin-paco-LHI-2015")
#setwd("C:\Users\vegay\Documents\CCASAnet\Paco_Impact of LHI on mortality")
#Drop what is in global environment
rm(list=ls())

#Reading tables with information in csv format
basic<-read.csv("basic.csv")
cd4<-read.csv("lab_cd4.csv")
rna<-read.csv("lab_rna.csv")
follow<-read.csv("follow.csv")
visit<-read.csv("visit.csv")
art<-read.csv("art.csv")
ce<-read.csv("ce.csv")
load("AIDSstatus.rda")      
load("AIDSstatusEnrol.rda")

#To indicate duplicated records
ord<-with(art,order(site,patient_id,as.Date(art_sd)))
junk<-data.frame(art$patient_id,art$site)
junk<-junk[ord,]
iddup<-duplicated(junk)
head(iddup)

art0<-art[ord,]
art2<-art0[iddup==FALSE,]
head(art2)
art3<-art2[,c("patient_id","site","art_sd","art_class")]
head(art3)
art3$FirstART_d<-as.Date(art3$art_sd)

art4<-art3[,c('site','patient_id','art_class','FirstART_d')]


##
basicA<-merge(basic,AIDSstatus,by.x=c("patient_id","site"),by.y=c("patient_id","site"), all.x=TRUE, all.y=FALSE)
basicA$included<-with(basicA, ifelse(recart_y==0,1,0))
basic2<-basicA[basicA$included==1, ]
save(basic2,file="basic2.rda")
basic2A<-with(basic2,data.frame(patient_id,site,birth_d,baseline_d,hivdiagnosis_d,aids_d,aids_cl_d ,
                                mode , mode_oth, aids_y ,center, clinicaltrial_y, male ,              
                                recart_y,preARTAIDS.clinical,preARTAIDS.all, included ))

##We select as AIDS patients reported with clinical AIDS, If clinical AIDS was unknown, the definition of AIDS including
##CD4 count was recorded.
basic2A$AIDS_ART<-ifelse(basic2A$preARTAIDS.clinical!="Unknown",basic2A$preARTAIDS.clinical,basic2A$preARTAIDS.all)
basic2A$AIDS_ART<-ifelse(basic2A$AIDS_ART==3,NA,basic2A$AIDS_ART)


##
basicB<-merge(basic2A,AIDSstatusEnrol,by.x=c("patient_id","site"),by.y=c("patient_id","site"), all.x=TRUE, all.y=FALSE)

##We select as AIDS patients reported with clinical AIDS, If clinical AIDS was unknown, the definition of AIDS including
##CD4 count was recorded.
basicB$AIDS_Enrol<-ifelse(basicB$preEnrolAIDS.clinical!="Unknown",basicB$preEnrolAIDS.clinical,basicB$preEnrolAIDS.all)
basicB$AIDS_Enrol<-ifelse(basicB$AIDS_Enrol==3,NA,basicB$AIDS_Enrol)


#Merge dataset with basic information and with the patients selected for ART criteria
basic2B<-merge(basicB,art4,by.x=c("site","patient_id"),by.y=c("site","patient_id"),all.x=TRUE,all.y=FALSE, sort==TRUE)
head(basic2B)
basic2B<-basic2B[!is.na(basic2B$site),]

basic2B$FirstART_d<-as.Date(basic2B$FirstART_d)
basic2B$birth_d<-as.Date(basic2B$birth_d)
basic2B$baseline_d<-as.Date(basic2B$baseline_d)
basic2B$hivdiagnosis_d<-as.Date(basic2B$hivdiagnosis_d)

basic2B<-basic2B[as.Date(basic2B$baseline_d)!="1900-01-01",]
##Excluded  47 patients w/o baseline date

#Which are not on treatment
basic2B$notx<-with(basic2B, ifelse(is.na(basic2B$FirstART_d),1,0))

#All HIV-infected patients enrolling in all CCASAnet sites since 2001 
bas.include<-with(basic2B, ifelse(as.Date(baseline_d)>as.Date("2000-12-31"), 1, 0))
table(bas.include)

##Older than 18
basic2B$age<-with(basic2B, (as.numeric(as.Date(baseline_d))-as.numeric(as.Date(birth_d)))/365.25 )

#Creating a dataset with all patients selected with the dummy variable included
basic3<-basic2B[bas.include==1 & basic2B$age>=18,]

## Excluding patients from Haiti because all of them started ART.
basic3$site.center<-with(basic3, paste(site,center,sep="-"))
basic3<-basic3[basic3$site!="haiti",]

##Started ART more than 30 days before baseline
base.after.art<-with(basic3, ifelse(is.na(FirstART_d),0,
                                     ifelse(as.Date(baseline_d)>as.Date(FirstART_d)+30,1,0)))
table(base.after.art)
basic3a<-basic3[base.after.art==0,]

##For those who started ART before baseline (within 30 days), we are re-defining baseline_d as FirstART_d
basic3a$baseline_d<-with(basic3a, as.Date(ifelse(is.na(FirstART_d),as.character(baseline_d),
                                           ifelse(as.Date(baseline_d)>as.Date(FirstART_d),as.character(FirstART_d),
                                                  as.character(baseline_d)))))
basic3a$AIDS_ART1<-with(basic3a, ifelse(is.na(AIDS_ART),"Unknown",
                                 ifelse(AIDS_ART==2,"not AIDS","AIDS")))

basic3a$AIDS_Enrol1<-with(basic3a, ifelse(is.na(FirstART_d),as.character(AIDS_Enrol),
                                   ifelse(baseline_d==FirstART_d,as.character(AIDS_ART1),
                                          as.character(AIDS_Enrol))))
basic3a$AIDS_Enrol<-basic3a$AIDS_Enrol1
basic3a$AIDS_Enrol1<-NULL

#Merge last dataset with follow information 
follow$death_D<-as.Date(follow$death_d,"%Y-%m-%d") 
follow$l_alive_d<-as.Date(follow$l_alive_d)

basic4<-merge(basic3a,follow,by.x=c("patient_id","site"),by.y=c("patient_id","site"),all.x=TRUE,all.y=FALSE)
head(basic4)

##NUmber of deaths in patients without treatment
table(basic4$death_y,basic4$notx)

#By site
table(basic4$site,basic4$death_y,basic4$notx)
table(basic4$site,basic4$death_y,basic4$notx==1)


##Merge with CD4 to define LT
basic5<-merge(basic4,cd4,by.x=c("patient_id","site"),by.y=c("patient_id","site"),all.x=TRUE,all.y=FALSE)
head(basic5)
basic5$cd4_d<-as.Date(basic5$cd4_d)

###CD4 at Baseline extended Paco (-360, 90)
#To create CD4 at Baseline in a range of 180 days before and 90 days after enrolment but previous to tx
basic5E5<-basic5[,]
basic5E5$difdates<-(as.numeric(basic5E5$cd4_d)-as.numeric(basic5E5$baseline_d))
basic6E5<-basic5E5[basic5E5$difdates<= 90 & basic5E5$difdates>= -360, ]
basic6E5$cd4aux<-with(basic6E5, ifelse(is.na(cd4_d),NA,
                                ifelse(is.na(FirstART_d),abs(difdates),
                                ifelse(cd4_d<FirstART_d+7,abs(difdates),99999))))
#####  Added by Bryan on 8 December, 2015  to capture those CD4<350 prior to baseline that may not have been the closest to baseline (and were therefore missed)
basic6E5$cd4lt350.prior<-with(basic6E5, ifelse(is.na(cd4_d)|is.na(cd4_v),NA,
                                        ifelse(difdates<=0&cd4_v<350,-1,0)))

ord<-with(basic6E5, order(site,patient_id,cd4lt350.prior,cd4aux))
basic7E5<-basic6E5[ord,]

basic7E5<-basic7E5[!is.na(basic7E5$patient_id),]

# 
# 

basic8E5<-basic7E5[!duplicated(cbind(basic7E5$site,basic7E5$patient_id)),]
basic8E5$cd4Enrol_ext4<-with(basic8E5, ifelse(cd4aux!=99999,cd4_v,99999))

basic9E5<-basic8E5[,c('site','patient_id','cd4Enrol_ext4')]

##Merge CD4 at Enrolment info with actual database
basic115<-merge(basic4, basic9E5,all.x=TRUE, all.y=FALSE, by.x=c("patient_id","site"),by.y=c("patient_id","site"))
head(basic115)

basic115$cd4Enrol_ext4=with(basic115,ifelse(cd4Enrol_ext4!=99999,cd4Enrol_ext4,NA))

# 
# 
# 
basic12<-basic115

###Are not on treatment really? VL<400 previous to HAART
basic13A<-merge(basic12,rna,by.x=c("patient_id","site"),by.y=c("patient_id","site"),all.x=TRUE,all.y=FALSE,sort=TRUE)
head(basic13A)
basic13A$rna_d<-as.Date(basic13A$rna_d)

basic13A$firstInd<-with(basic13A, ifelse(rna_v<=400 & as.Date(rna_d)<=as.Date(FirstART_d), 1, 0))

ord6<-order(basic13A$site,basic13A$patient_id,-(basic13A$firstInd),as.numeric(basic13A$rna_d))
head(ord6)
basic13B<-basic13A[ord6,]
head(basic13B)

basic13C<-basic13B[!duplicated(cbind(basic13B$site,basic13B$patient_id)),]


basic13D<-basic13C[is.na(basic13C$firstInd) | basic13C$firstInd!=1,]

basic13D$rna_d<-as.Date(basic13D$rna_d, "%Y-%m-$d")


########################
##Bryan 20 apr 2015
######################


##Late presentation at enrolment: LP=1, CD4 count at enrol <350 or ADE and LP=0 CD4 at enrol >350
##
sum(is.na(basic13D$AIDS_Enrol))
####  Everyone with a missing CD4 will be excluded from these analyses (i.e. LP=NA)
basic13D$LP4<-with(basic13D,ifelse(is.na(cd4Enrol_ext4),NA,
                            ifelse(cd4Enrol_ext4<350|AIDS_Enrol=="AIDS", 1,0)))


basic13D$LP<-basic13D$LP4
basic13D$LP4<-NULL
basic13D$cd4Enrol<-basic13D$cd4Enrol_ext4
basic13D$cd4Enrol_ext4<-NULL

basic13D$route<-with(basic13D,ifelse(mode=="Unknown","Unknown", 
                                 ifelse(mode=="Heterosexual contact","Heterosexual",
                                        ifelse(mode=="Bisexual" | mode=="Homosexual contact","Homosexual", "other"))))


######  New additions by Bryan on 8 December, 2015  (TO MAKE SURE WE CAPTURE CE's PRIOR TO ENROLLMENT IN CE TABLE)

ce$ce_d<-as.Date(ce$ce_d,format="%d/%m/%Y")
#######Including Clinical endpoints data
ce$EXCL<-with(ce, ifelse(ce_id=="nade_bone" | 
                           ce_id=="nade_cancer" | 
                           ce_id=="nade_cerebrovascular" |
                           ce_id=="nade_chagas"  | 
                           ce_id=="nade_coronary" | 
                           ce_id=="nade_denge" | 
                           ce_id=="nade_dengue" | 
                           ce_id=="nade_diabetes" | 
                           ce_id=="nade_dyslipidemia"   |
                           ce_id=="nade_hepatitis_b" | 
                           ce_id=="nade_hepatitis_c" | 
                           ce_id=="nade_htlv"  |
                           ce_id=="nade_leishmaniasis" | 
                           ce_id=="nade_liver" | 
                           ce_id=="nade_malaria" |
                           ce_id=="nade_other" | 
                           ce_id=="nade_renal" 
                         , 1,0) ) 
ce2<-ce[ce$EXCL==0,]
ord<-with(ce,order(site,patient_id,as.Date(ce_d)))
ce3<-ce2[ord,]

junk<-data.frame(ce3$patient_id,ce3$site)
junk<-junk[ord,]
iddup<-duplicated(junk)
head(iddup)

ce4<-ce3[iddup==FALSE,]
head(ce4)

ce5<-ce4[,c('site','patient_id','ce_d','ce_id')]
head(ce5)

basic13D1<-merge(basic13D,ce5,by=c("site","patient_id"),all.x=TRUE)
basic13D1$LP1<-with(basic13D1, ifelse(!is.na(ce_d)&!is.na(LP)&ce_d<=baseline_d,1,LP))
basic13D1$AIDS_Enrol<-with(basic13D1, as.character(ifelse(!is.na(ce_d)&!is.na(LP)&ce_d<=baseline_d,"AIDS",AIDS_Enrol)))
basic13D1$LP<-basic13D1$LP1
basic13D1$LP1<-NULL

basic13D<-basic13D1

#####Mortality in LP

save(basic13D,file="basic13D-CD4-350.rda")

load("basic13D-CD4-350.rda")

basic13E<-basic13D[!is.na(basic13D$LP),]




library("survival")
library("rms")
library("Hmisc")

basic13E$time<-with(basic13E, (as.numeric(as.Date(l_alive_d))-as.numeric(as.Date(baseline_d)))/365.25 )
plot(survfit(Surv(basic13E$time,basic13E$death_y)~basic13E$LP))

basic13E$baseline_d_num<-with(basic13E, as.numeric(as.Date(baseline_d)))



save(basic13E,file="basic13E-CD4-350.rda")

load("basic13E-CD4-350.rda")


dd<-datadist(basic13E)
options(datadist='dd')

mod<-lrm(LP ~ site + rcs(baseline_d_num,5) + male + rcs(age,5), data=basic13E, x=TRUE, y=TRUE )
anova(mod)
ests<-rbind(
  summary(mod)[c("male",
                 "site - argentina:haiti","site - brazil:haiti",
                 "site - chile:haiti","site - honduras:haiti",
                 "site - mexico:haiti","site - peru:haiti"),c(4,5)],
  summary(mod, age=c(20,30))["age",c(4,5)],
  summary(mod, age=c(20,40))["age",c(4,5)],
  summary(mod, age=c(20,50))["age",c(4,5)],
  summary(mod, age=c(20,60))["age",c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2003-07-01"))))[c("baseline_d_num"),c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2005-07-01"))))[c("baseline_d_num"),c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2007-07-01"))))[c("baseline_d_num"),c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2009-07-01"))))[c("baseline_d_num"),c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2011-07-01"))))[c("baseline_d_num"),c(4,5)],
  summary(mod, baseline_d_num=as.numeric(as.Date(c("2001-07-01","2013-07-01"))))[c("baseline_d_num"),c(4,5)])

or<-exp(ests[,1])
lower<-exp(ests[,1]-1.96*ests[,2])
upper<-exp(ests[,1]+1.96*ests[,2])
names<-c("male","argentina:haiti","brazil:haiti","chile:haiti","honduras:haiti","mexico:haiti","peru:haiti",
         "age - 30:20","age - 40:20","age - 50:20","age - 60:20",
         "year - 2003:2001","year - 2005:2001","year - 2007:2001","year - 2009:2001","year - 2011:2001","year - 2013:2001")
or.LP<-data.frame(names, or, lower, upper)
or.LP     #####  The odds ratios for late presentation


plot(Predict(mod, baseline_d_num))
plot(Predict(mod, age))

lin.pred<-predict(mod)
p.pred<-exp(lin.pred)/(1+exp(lin.pred))

boxplot(p.pred~basic13E$LP)
wgt<-ifelse(basic13E$LP==1,1/p.pred,1/(1-p.pred))

plot(survfit(Surv(basic13E$time,basic13E$death_y)~basic13E$LP,weight=wgt),ymin=.8,xmax=10,mark.time=FALSE)

S.LP0<-with(basic13E, Surv(time[LP==0],death_y[LP==0]))
S.LP1<-with(basic13E, Surv(time[LP==1],death_y[LP==1]))

plot(survfit(Surv(basic13E$time,basic13E$death_y)~basic13E$LP,weight=wgt),ymin=.8,xmax=10, 
     conf.int=FALSE, mark.time=FALSE, xlab="Years from Start of ART",ylab="Probability of Death")
lines(survfit(S.LP0~1,weight=wgt[basic13E$LP==0]), mark.time=FALSE, col=2)
lines(survfit(S.LP1~1,weight=wgt[basic13E$LP==1]), mark.time=FALSE, col=3)
legend("bottomleft",c("CD4>=350 and no AIDS at enrollment","CD4<350 or AIDS at enrollment"),col=c(2,3),lty=rep(1,2),bty="n")
title("Adjusted Survival Estimates")



#plot(survfit(Surv(basic13E$time,basic13E$death_y)~basic13E$LP))

#mod.surv<-coxph(Surv(basic13E$time,basic13E$death_y)~basic13E$LP)
mod.surv<-coxph(Surv(basic13E$time,basic13E$death_y)~basic13E$LP,weight=wgt)
summary(mod.surv)

stuff<-survfit(Surv(basic13E$time,basic13E$death_y)~basic13E$LP,weight=wgt)
stuff<-with(basic13E,survfit(Surv(time,death_y)~LP,weight=wgt))
stuff$strata
stuff.strat<-c(rep("LP=0",stuff$strata[1]),rep("LP=1",stuff$strata[2]))
table(stuff.strat)


att.risk<-function(year){
  p0<-1-min(stuff$surv[stuff$time<year&stuff.strat=="LP=0"])
  p1<-1-min(stuff$surv[stuff$time<year&stuff.strat=="LP=1"])
  p.LP<-table(basic13E$LP)[2]/sum(table(basic13E$LP))
  c(year,(p1-p0)/p1,(p1*p.LP+p0*(1-p.LP) - p0)/(p1*p.LP+p0*(1-p.LP)))
}

atr.5<-att.risk(.5)
atr1<-att.risk(1)
atr2<-att.risk(2)
atr3<-att.risk(3)
atr5<-att.risk(5)
atr10<-att.risk(10)


###  Bootstrap CI 

basic13E.clean<-basic13E[!is.na(basic13E$LP),]
n<-length(basic13E.clean$LP)

Nboot<-200
excess.mort<-att.mort<-matrix(NA,Nboot,6)
for (ii in 1:Nboot){
  boot<-sample(1:n,n,replace=TRUE)
  basic13Eb<-basic13E.clean[boot,]
  modb<-glm(LP ~ site + rcs(baseline_d_num,5) + male + rcs(age,5), data=basic13Eb, family="binomial")
  lin.pred<-predict(modb)
  p.pred<-exp(lin.pred)/(1+exp(lin.pred))
  wgt<-ifelse(basic13Eb$LP==1,1/p.pred,1/(1-p.pred))
  stuff<-with(basic13Eb,survfit(Surv(time,death_y)~LP,weight=wgt))
  stuff.strat<-c(rep("LP=0",stuff$strata[1]),rep("LP=1",stuff$strata[2]))
  ar.5<-att.risk(.5)
  ar1<-att.risk(1)
  ar2<-att.risk(2)
  ar3<-att.risk(3)
  ar5<-att.risk(5)
  ar10<-att.risk(10)
  excess.mort[ii,]<-c(ar.5[2],ar1[2],ar2[2],ar3[2],ar5[2],ar10[2])
  att.mort[ii,]<-c(ar.5[3],ar1[3],ar2[3],ar3[3],ar5[3],ar10[3])
}

em.sd<-apply(excess.mort,2,sd)
am.sd<-apply(att.mort,2,sd)


years<-rep(c(.5,1,2,3,5,10),2)
ests<-c(atr.5[2],atr1[2],atr2[2],atr3[2],atr5[2],atr10[2],
        atr.5[3],atr1[3],atr2[3],atr3[3],atr5[3],atr10[3])
lowers<-ests-1.96*c(em.sd,am.sd)
uppers<-ests+1.96*c(em.sd,am.sd)
what<-c(rep("em",6),rep("ar",6))

attributable.risks<-data.frame(years,what,ests,lowers,uppers)

save(attributable.risks,file="attributablerisks-CD4-350.rda")

levels(attributable.risks$what)[levels(attributable.risks$what)=="em"]<-"In LP"
levels(attributable.risks$what)[levels(attributable.risks$what)=="ar"]<-"In All"
names(attributable.risks)[names(attributable.risks)=="what"]  <- "Group"


save(attributable.risks,file="attributablerisks-CD4-350.rda")


bp<-ggplot(data=attributable.risks, aes(x=years, y=ests, group=Group, shape=Group, color=Group, xmin=0.5, xmax=10)) +   
  geom_line(aes(y=lowers, group=Group, color=Group), linetype="dotted") +
  geom_line(aes(y=uppers, group=Group, color=Group),  linetype="dotted") +
  geom_line() +
  scale_x_discrete(name="Years from start ART") +
  scale_y_continuous(name="Proportion")


bp + theme(panel.grid.minor.x=element_blank(),panel.grid.major.x=element_blank(), panel.grid.minor.y=element_blank(),
        panel.grid.major.y=element_blank())

  





